import java.awt.*;
import javax.swing.*;

public class GridBag extends JPanel {
	
	private GridBagLayout 	gridBagLayout;
	
	public GridBag() {

		gridBagLayout = new GridBagLayout();
		GridBagConstraints constraints = new GridBagConstraints();
		
		setLayout(gridBagLayout);
		
		constraints.insets = new Insets(4,4,4,4);
		constraints.ipadx =3;
		constraints.ipady =3;
		constraints.fill = GridBagConstraints.NONE;
		constraints.weightx = 0.5; 
		constraints.weighty = 0.5;
		constraints.anchor = GridBagConstraints.CENTER;

		constraints.gridx = 0;
		constraints.gridy = 0;
		constraints.gridwidth = 1;
		constraints.gridheight = 1;
		buildButton("Button 1",gridBagLayout,constraints);		

		constraints.gridx = 1;
		constraints.gridy = 0;
		constraints.gridwidth = 1;
		constraints.gridheight = 2;
		buildButton("Button 2",gridBagLayout,constraints);		
		
		constraints.gridx = 2;
		constraints.gridy = 0;
		constraints.gridwidth = 2;
		constraints.gridheight = 1;
		buildButton("Button 3",gridBagLayout,constraints);		
		
		constraints.gridx = 3;
		constraints.gridy = 1;
		constraints.gridwidth = 1;
		constraints.gridheight = 2;
		constraints.fill = GridBagConstraints.VERTICAL;
		buildButton("Button 4",gridBagLayout,constraints);		

		constraints.gridx = 0;
		constraints.gridy = 1;
		constraints.gridwidth = 1;
		constraints.gridheight = 1;
		constraints.fill = GridBagConstraints.HORIZONTAL;
		buildButton("Button 5",gridBagLayout,constraints);		
	
	}
	
	protected void buildButton(String name,
                              GridBagLayout gridbag,
                              GridBagConstraints c) {
    Button button = new Button(name);
    gridBagLayout.setConstraints(button, c);
    add(button);
 }

}